searchData={"items":[{"type":"module","title":"XRPL","doc":"XRPL is a library for interacting with the XRP Ledger.","ref":"XRPL.html"},{"type":"function","title":"XRPL.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#delete/3"},{"type":"function","title":"XRPL.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#delete!/3"},{"type":"function","title":"XRPL.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#get/3"},{"type":"function","title":"XRPL.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#get!/3"},{"type":"function","title":"XRPL.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#head/3"},{"type":"function","title":"XRPL.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#head!/3"},{"type":"macro","title":"XRPL.is_hash/1","doc":"Many objects in the XRP Ledger, particularly transactions and ledgers, are uniquely identified by a 256-bit hash value.\nThis value is typically calculated as a \"SHA-512Half\", which calculates a SHA-512 hash from some contents, then takes the first half of the output (That's 256 bits, which is 32 bytes, or 64 characters of the hexadecimal representation).\nSince the hash of an object is derived from the contents in a way that is extremely unlikely to produce collisions, two objects with the same hash can be considered the same.\n\nOfficial documentation: https://xrpl.org/basic-data-types.html#hashes","ref":"XRPL.html#is_hash/1"},{"type":"macro","title":"XRPL.is_ledger_index/1","doc":"Ledger Index is a type on the XRPL blockchain, usually expressed by an Int, a Hash or a String.\n\nOfficial documentation: https://xrpl.org/basic-data-types.html#ledger-index","ref":"XRPL.html#is_ledger_index/1"},{"type":"macro","title":"XRPL.is_ledger_index_shortcut/1","doc":"","ref":"XRPL.html#is_ledger_index_shortcut/1"},{"type":"function","title":"XRPL.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#options/3"},{"type":"function","title":"XRPL.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#options!/3"},{"type":"function","title":"XRPL.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#patch/4"},{"type":"function","title":"XRPL.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#patch!/4"},{"type":"function","title":"XRPL.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#post/4"},{"type":"function","title":"XRPL.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#post!/4"},{"type":"function","title":"XRPL.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#put/4"},{"type":"function","title":"XRPL.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"XRPL.html#put!/4"},{"type":"function","title":"XRPL.request/2","doc":"Perform a request.","ref":"XRPL.html#request/2"},{"type":"function","title":"Options - XRPL.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"XRPL.html#request/2-options"},{"type":"function","title":"Examples - XRPL.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"XRPL.html#request/2-examples"},{"type":"function","title":"XRPL.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"XRPL.html#request!/2"},{"type":"function","title":"XRPL.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#trace/3"},{"type":"function","title":"XRPL.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"XRPL.html#trace!/3"},{"type":"macro","title":"XRPL.unwrap_or_raise/1","doc":"","ref":"XRPL.html#unwrap_or_raise/1"},{"type":"function","title":"XRPL.xrpl/2","doc":"","ref":"XRPL.html#xrpl/2"},{"type":"type","title":"XRPL.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"XRPL.html#t:option/0"},{"type":"module","title":"XRPL.Account","doc":"XRPL.Account is a module to interact with accounts on the XRP Ledger.\nAn account in the XRP Ledger represents a holder of XRP and a sender of transactions. Use these methods to work with account info.\n\nOfficial RPC documentation https://xrpl.org/account-methods.html","ref":"XRPL.Account.html"},{"type":"function","title":"XRPL.Account.account_channels/2","doc":"The account_channels method returns information about an account's Payment Channels.\nThis includes only channels where the specified account is the channel's source, not the destination. (A channel's \"source\" and \"owner\" are the same.)\nAll information retrieved is relative to a particular version of the ledger.\n\nOfficial documentation: https://xrpl.org/account_channels.html","ref":"XRPL.Account.html#account_channels/2"},{"type":"function","title":"XRPL.Account.account_channels!/2","doc":"","ref":"XRPL.Account.html#account_channels!/2"},{"type":"function","title":"XRPL.Account.account_currencies/2","doc":"The account_currencies command retrieves a list of currencies that an account can send or receive, based on its trust lines\n\nOfficial documentation: https://xrpl.org/account_currencies.html","ref":"XRPL.Account.html#account_currencies/2"},{"type":"function","title":"XRPL.Account.account_currencies!/1","doc":"","ref":"XRPL.Account.html#account_currencies!/1"},{"type":"function","title":"XRPL.Account.account_info/2","doc":"The account_info command retrieves information about an account, its activity, and its XRP balance.\nAll information retrieved is relative to a particular version of the ledger.\n\nOfficial documentation: https://xrpl.org/account_info.html","ref":"XRPL.Account.html#account_info/2"},{"type":"function","title":"XRPL.Account.account_info!/1","doc":"","ref":"XRPL.Account.html#account_info!/1"},{"type":"function","title":"XRPL.Account.account_lines/1","doc":"The account_lines command returns information about an account's trust lines, including balances in all non-XRP currencies and assets.\nAll information retrieved is relative to a particular version of the ledger.\n\nOfficial documentation: https://xrpl.org/account_lines.html","ref":"XRPL.Account.html#account_lines/1"},{"type":"function","title":"XRPL.Account.account_lines!/1","doc":"","ref":"XRPL.Account.html#account_lines!/1"},{"type":"function","title":"XRPL.Account.account_nfts/2","doc":"The account_nfts method returns a list of NFToken objects for the specified account.\n\nOfficial documentation: https://xrpl.org/account_nfts.html","ref":"XRPL.Account.html#account_nfts/2"},{"type":"function","title":"XRPL.Account.account_nfts!/1","doc":"","ref":"XRPL.Account.html#account_nfts!/1"},{"type":"function","title":"XRPL.Account.account_objects/2","doc":"The account_objects command returns the raw ledger format for all objects owned by an account.\nFor a higher-level view of an account's trust lines and balances, see the account_lines method instead.\n\nRef: https://xrpl.org/account_objects.html","ref":"XRPL.Account.html#account_objects/2"},{"type":"function","title":"XRPL.Account.account_objects!/2","doc":"","ref":"XRPL.Account.html#account_objects!/2"},{"type":"function","title":"XRPL.Account.account_offers/2","doc":"The account_offers method retrieves a list of offers made by a given account that are outstanding as of a particular ledger version.\n\nRef: https://xrpl.org/account_offers.html","ref":"XRPL.Account.html#account_offers/2"},{"type":"function","title":"XRPL.Account.account_offers!/2","doc":"","ref":"XRPL.Account.html#account_offers!/2"},{"type":"function","title":"XRPL.Account.account_tx/4","doc":"The account_tx method retrieves a list of transactions that involved the specified account.\n\nRef: https://xrpl.org/account_tx.html","ref":"XRPL.Account.html#account_tx/4"},{"type":"function","title":"XRPL.Account.account_tx!/4","doc":"","ref":"XRPL.Account.html#account_tx!/4"},{"type":"function","title":"XRPL.Account.gateway_balance/2","doc":"The gateway_balances command calculates the total balances issued by a given account, optionally excluding amounts held by operational addresses.\n\nRef: https://xrpl.org/gateway_balances.html","ref":"XRPL.Account.html#gateway_balance/2"},{"type":"function","title":"XRPL.Account.gateway_balance!/2","doc":"","ref":"XRPL.Account.html#gateway_balance!/2"},{"type":"function","title":"XRPL.Account.noripple_check/3","doc":"The noripple_check command provides a quick way to check the status of the Default Ripple field for an account and the No Ripple flag of its trust lines, compared with the recommended settings.\n\nRef: https://xrpl.org/noripple_check.html","ref":"XRPL.Account.html#noripple_check/3"},{"type":"function","title":"XRPL.Account.noripple_check!/3","doc":"","ref":"XRPL.Account.html#noripple_check!/3"},{"type":"module","title":"XRPL.Ledger","doc":"XRPL.Ledger is a module to interact with ledgers on the XRP Ledger.\nA ledger version contains a header, a transaction tree, and a state tree, which contain account settings, trustlines, balances, transactions, and other data.\nUse these methods to retrieve ledger info.\n\nOfficial RPC documentation: https://xrpl.org/ledger-methods.html","ref":"XRPL.Ledger.html"},{"type":"function","title":"XRPL.Ledger.ledger/1","doc":"Retrieve information about the public ledger.\n\nOfficial documentation: https://xrpl.org/ledger.html","ref":"XRPL.Ledger.html#ledger/1"},{"type":"function","title":"XRPL.Ledger.ledger!/1","doc":"","ref":"XRPL.Ledger.html#ledger!/1"},{"type":"function","title":"XRPL.Ledger.ledger_closed/0","doc":"The ledger_closed method returns the unique identifiers of the most recently closed ledger.\n(This ledger is not necessarily validated and immutable yet.)\n\nOfficial documentation: https://xrpl.org/ledger_closed.html","ref":"XRPL.Ledger.html#ledger_closed/0"},{"type":"function","title":"XRPL.Ledger.ledger_closed!/0","doc":"","ref":"XRPL.Ledger.html#ledger_closed!/0"},{"type":"function","title":"XRPL.Ledger.ledger_current/0","doc":"The ledger_current method returns the unique identifiers of the current in-progress ledger.\n\nThis command is mostly useful for testing, because the ledger returned is still in flux.\n\nOfficial documentation: https://xrpl.org/ledger_current.html","ref":"XRPL.Ledger.html#ledger_current/0"},{"type":"function","title":"XRPL.Ledger.ledger_current!/0","doc":"","ref":"XRPL.Ledger.html#ledger_current!/0"},{"type":"function","title":"XRPL.Ledger.ledger_data/1","doc":"The ledger_data method retrieves contents of the specified ledger.\nYou can iterate through several calls to retrieve the entire contents of a single ledger version.\n\nOfficial documentation: https://xrpl.org/ledger_data.html","ref":"XRPL.Ledger.html#ledger_data/1"},{"type":"function","title":"XRPL.Ledger.ledger_data!/1","doc":"","ref":"XRPL.Ledger.html#ledger_data!/1"},{"type":"type","title":"XRPL.Ledger.currency_without_amount/0","doc":"","ref":"XRPL.Ledger.html#t:currency_without_amount/0"},{"type":"module","title":"XRPL.LedgerEntry","doc":"The ledger_entry method returns a single ledger entry from the XRP Ledger in its raw format.\nSee [ledger format](https://xrpl.org/ledger-object-types.html) for information on the different types of entries you can retrieve.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html","ref":"XRPL.LedgerEntry.html"},{"type":"function","title":"XRPL.LedgerEntry.account_root/2","doc":"","ref":"XRPL.LedgerEntry.html#account_root/2"},{"type":"function","title":"XRPL.LedgerEntry.by_id/2","doc":"Retrieve any type of ledger object by its unique ID.\n\nOfficial documentation: https://xrpl.org/ledger_entry.html#get-ledger-object-by-id","ref":"XRPL.LedgerEntry.html#by_id/2"},{"type":"function","title":"XRPL.LedgerEntry.by_id!/2","doc":"","ref":"XRPL.LedgerEntry.html#by_id!/2"},{"type":"function","title":"XRPL.LedgerEntry.ledger_entry/3","doc":"","ref":"XRPL.LedgerEntry.html#ledger_entry/3"},{"type":"function","title":"XRPL.LedgerEntry.ledger_entry/4","doc":"","ref":"XRPL.LedgerEntry.html#ledger_entry/4"},{"type":"module","title":"XRPL.Middleware.Error","doc":"Makes requests that don't respond to HTTP Success codes to return as a error\n\n\n#","ref":"XRPL.Middleware.Error.html"},{"type":"module","title":"Example usage - XRPL.Middleware.Error","doc":"```\ndefmodule MyClient do\n  use Tesla\n\n  plug(XRPL.Middleware.Error)\nend\n```","ref":"XRPL.Middleware.Error.html#module-example-usage"},{"type":"function","title":"XRPL.Middleware.Error.call/3","doc":"","ref":"XRPL.Middleware.Error.html#call/3"},{"type":"module","title":"XRPL.PathOrderbook","doc":"XRPL.PathOrderbook is a module to interact with orderbook modules on the XRP Ledger.\n\nPaths define a way for payments to flow through intermediary steps on their way from sender to receiver.\nPaths enable cross-currency payments by connecting sender and receiver through order books.\nUse these methods to work with paths and other books.\n\nOfficial RPC documentation https://xrpl.org/path-and-order-book-methods.html","ref":"XRPL.PathOrderbook.html"},{"type":"module","title":"XRPL.Payment","doc":"XRPL.Payment is a module to interact with payment modules on the XRP Ledger.\n\nPayment channels are a tool for facilitating repeated, unidirectional payments, or temporary credit between two parties.\nUse these methods to work with payment channels.\n\nOfficial documentation: https://xrpl.org/payment-channel-methods.html","ref":"XRPL.Payment.html"},{"type":"module","title":"XRPL.ServerInfo","doc":"XRPL.ServerInfo is a module to interact with server_info modules on the XRP Ledger.\n\nUse these methods to retrieve information about the current state of the rippled server.\n\nOfficial documentation: https://xrpl.org/server-info-methods.html","ref":"XRPL.ServerInfo.html"},{"type":"module","title":"XRPL.Transaction","doc":"XRPL.Transaction is a module to interact with transaction modules on the XRP Ledger.\nTransactions are the only thing that can modify the shared state of the XRP Ledger. All business on the XRP Ledger takes the form of transactions. Use these methods to work with transactions.\n\nOfficial RPC documentation https://xrpl.org/transaction-methods.html","ref":"XRPL.Transaction.html"},{"type":"exception","title":"XRPL.Error","doc":"","ref":"XRPL.Error.html"},{"type":"function","title":"XRPL.Error.exception/2","doc":"","ref":"XRPL.Error.html#exception/2"},{"type":"function","title":"XRPL.Error.message/1","doc":"","ref":"XRPL.Error.html#message/1"},{"type":"extras","title":"XRPL","doc":"# XRPL\n\nThis library intends to help Elixir developers to integrate and use [XRP Ledger Blockchain](https://xrpl.org/).\n\nIt allows you to interact with its HTTP API and is organized in a manner similar to the [official documentation](https://xrpl.org/http-websocket-apis.html).","ref":"readme.html"},{"type":"extras","title":"⚠️ BEWARE still in development - XRPL","doc":"This is currently a work in progress and there is still a lot to do. Any help is welcome!\n\n- [x] Account methods \n- [ ] Ledger methods\n- [ ] Transaction methods\n- [ ] Path and Order Book methods\n- [ ] Payment methods\n- [ ] Server methods\n- [ ] Clio methods\n- [ ] Utility methods","ref":"readme.html#beware-still-in-development"},{"type":"extras","title":"Installation - XRPL","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `xrpl` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:xrpl, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"}],"content_type":"text/markdown"}